/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription, NumberFunctionTypes } from './general';

export const NumberFunctions: Record<NumberFunctionTypes, GeneralDescription<NumberFunctionTypes>> = {
  [NumberFunctionTypes.ADD]: {
    key: 'numberFunctionAdd',
    name: 'Add',
    type: NumberFunctionTypes.ADD,
    description: 'Add two values',
    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '+', type: 'float' },
    logic: ['+', '@1', '@2'],
    icon: '+',
  },
  [NumberFunctionTypes.SUBTRACT]: {
    key: 'numberFunctionSubtract',
    name: 'Subtract',
    type: NumberFunctionTypes.SUBTRACT,
    description: 'Subtract two values',
    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '-', type: 'float' },
    logic: ['-', '@1', '@2'],
    icon: '-',
  },
  [NumberFunctionTypes.MULTIPLY]: {
    key: 'numberFunctionMultiply',
    name: 'Multiply',
    type: NumberFunctionTypes.MULTIPLY,
    description: 'Multiply two values',
    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '*', type: 'float' },
    logic: ['*', '@1', '@2'],
    icon: '×',
  },
  [NumberFunctionTypes.DIVIDE]: {
    key: 'numberFunctionDivide',
    name: 'Divide',
    type: NumberFunctionTypes.DIVIDE,
    description: 'Divide two values',

    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '/', type: 'float' },
    logic: ['/', '@1', '@2'],
    icon: '÷',
  },
};

/** All available functions in the function bar. */
export const MathFunctionArray: Array<GeneralDescription<NumberFunctionTypes>> = Object.values(NumberFunctions);
